/* ============================================================
 *
 * This file is a part of educazionik project
 * http://educazionik.sourceforge.net/
 *
 * Date        : 1/1/2003
 * Description : implementation of class qualisoftWindow
 *
 * Copyright 2003-2009 by Nicola De Filippo <nicola@nicoladefilippo.it>
 * Copyright 2009      by Angelo Naselli    <anaselli at linux dot it>
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * ============================================================ */

#include "qqualisoft_window.h"
#include <QMessageBox>

#include"dcr.h"
#include "aboutdlg.h"
#include "aggettivi_version.h"

qualisoftWindow::qualisoftWindow(QWidget *parent)
        : QMainWindow(parent)
{
    setupUi(this);
    m_title     = QString(APPL_NAME) + " V. " + QString(APPL_VERSION);
    m_data_path = QString(DATA_DIR) + QString('/');
    m_resource_path = QString(RESOURCE_DIR) + QString('/');
    setWindowTitle(m_title);
    setWindowIcon(QIcon( QPixmap(QString(RESOURCE_DIR) + "/educazionik.png")));

    QPalette palette;

    color_button = Qt::yellow;

    pushButton_avanti->setEnabled(false);

    scansionDialog = new dialogScansione;

    palette.setColor(QPalette::Button,color_button);
    pushButton_1->setPalette( palette );
    pushButton_2->setPalette( palette );
    pushButton_3->setPalette( palette );
    pushButton_4->setPalette( palette );
    pushButton_5->setPalette( palette );
    pushButton_avanti->setPalette( palette );


    /* Disable because not implementated */
    action_Carica->setDisabled(true);
    //action_Scansione->setDisabled(true);
    action_Colore_del_testo->setDisabled(true);
    action_Colore_sfondo_del_testo->setDisabled(true);
    action_Colore_finestra->setDisabled(true);
    action_Colore_componenti->setDisabled(true);
    action_Colore_testo_dei_componenti->setDisabled(true);
    action_Carica_2->setDisabled(true);
    action_Font->setDisabled(true);
    action_Manuale->setDisabled(true);

    timer = new QTimer(this);

    pExercise = new d_c_r(m_data_path + "aggettivi.txt");


    connect( pushButton_1, SIGNAL( pressed() ), this, SLOT( premuto1() ) );
    connect( pushButton_2, SIGNAL( pressed() ), this, SLOT( premuto2() ) );
    connect( pushButton_3, SIGNAL( pressed() ), this, SLOT( premuto3() ) );
    connect( pushButton_4, SIGNAL( pressed() ), this, SLOT( premuto4() ) );
    connect( pushButton_5, SIGNAL( pressed() ), this, SLOT( premuto5() ) );
    connect( pushButton_avanti, SIGNAL( pressed() ), this, SLOT( avanti() ) );
    connect(action_Esci_2, SIGNAL(triggered()), qApp, SLOT(quit()));
    connect(action_Ricomincia, SIGNAL(triggered()), this, SLOT(restart()));
    connect(action_Informazioni, SIGNAL(triggered()), this, SLOT(info()));
    connect( timer, SIGNAL(timeout()), SLOT(timeout()) );
    connect(action_Scansione, SIGNAL(triggered()), this, SLOT(scansione()));


    if (pExercise->errore() !=-1)
    {
        QString a[5],f;
        pExercise->frase(&a[0],f);
        label_3->setText(f);

        pushButton_1->setText(a[0]);
        pushButton_2->setText(a[1]);
        pushButton_3->setText(a[2]);
        pushButton_4->setText(a[3]);
        pushButton_5->setText(a[4]);


        pushButton_1->setFocus();

        // showFullScreen(); for final version

        //button_height=pushButton_1->height();
        //button_width=pushButton_1->width();
        //half_screen=(int)(this->width()/2);
        /*pushButton_1->setGeometry(half_screen-button_width-10,160,button_width,button_height);
        pushButton_2->setGeometry(half_screen+10,160,button_width,button_height);
        pushButton_3->setGeometry((int)(half_screen-button_width/2),160+button_height+10,button_width,button_height);
        pushButton_4->setGeometry(half_screen-button_width-10,160+2*(button_height+10),button_width,button_height);
        pushButton_5->setGeometry(half_screen+10,160+2*(button_height+10),button_width,button_height);


        pen = new QPen(red,2);*/

    }
    else
    {
        /*QMessageBox::critical( 0, "Aggettivi 1.0", QString("Non riesco a trovare il file /usr/local/educazionik/data/aggettivi.txt "));

        pushButton_1->hide();
        pushButton_2->hide();
        pushButton_3->hide();
        pushButton_4->hide();
        pushButton_5->hide();
        pushButton_avanti->hide();
        Button7->hide();
        Button9->hide();
        lcdNumber_1->hide();
        lcdNumber_2->hide();
        TextLabel2->hide();
        TextLabel1->hide();
        Label1->setText("Errore nel caricamento dei dati");*/
    }

}




void qualisoftWindow::premuto1()
{
    QPalette palette;
    if (pushButton_1->text() == pExercise->esatto())
    {
        lcdNumber_1->display(lcdNumber_1->intValue()+1);
        pushButton_avanti->setEnabled(true);
        label_3->setText(label_3->text()+' '+pushButton_1->text());
        enableButtons(false);
        label_4->setPixmap(QPixmap(m_resource_path + "smile.png"));
        if (scanOn)
        {
            timer->stop();
            //se scansione a rettangolo spostare rettangolo a pushButton_avanti
            if ( scansionMode == 1)
            {
                palette.setColor(QPalette::Button,color_button);
                pushButton_1->setPalette( palette );
                palette.setColor(QPalette::Button,scansionColor);
                pushButton_avanti->setPalette( palette );
                //pushButton_1->setPaletteBackgroundColor(color_button);
                //pushButton_avanti->setPaletteBackgroundColor(form_scansione->cScan());
            }
            else
            {
                //moveRect(pushButton_1,pushButton_avanti);
            }

            pushButton_avanti->setFocus();
        }
    }
    else
    {
        lcdNumber_2->display(lcdNumber_2->intValue()+1);
        label_4->setPixmap(QPixmap(m_resource_path + "frown.png"));
        pushButton_1->setEnabled(false);
        if (scanType == 1)
        {
            //se scansione a rettangolo skippare e settare il timer
            if (scansionMode == 1)
            {
                palette.setColor(QPalette::Button,color_button);
                pushButton_1->setPalette( palette );
            }
            skipEnabled(0);
            timer->start(scansionGap);
        }
        else
        {
            if (scansionMode == 2)
                skipEnabled(0);
        }
    }


}

void qualisoftWindow::premuto2()
{
    QPalette palette;
    if (pushButton_2->text() == pExercise->esatto())
    {
        lcdNumber_1->display(lcdNumber_1->intValue()+1);
        pushButton_avanti->setEnabled(true);
        label_3->setText(label_3->text()+' ' +pushButton_2->text());
        enableButtons(false);
        label_4->setPixmap(QPixmap(m_resource_path + "smile.png"));
        if (scanOn)
        {
            timer->stop();
            if (scansionMode == 1)
            {
                palette.setColor(QPalette::Button,color_button);
                pushButton_2->setPalette( palette );
                palette.setColor(QPalette::Button,scansionColor);
                pushButton_avanti->setPalette( palette );
            }
            else
            {
                //moveRect(pushButton_2,pushButton_avanti);
            }
            pushButton_avanti->setFocus();
        }
    }
    else
    {
        lcdNumber_2->display(lcdNumber_2->intValue()+1);
        label_4->setPixmap(QPixmap(m_resource_path + "frown.png"));
        pushButton_2->setEnabled(false);
        if (scanType == 1)
        {
            if (scansionMode == 1)
            {
                palette.setColor(QPalette::Button,color_button);
                pushButton_2->setPalette( palette );
            }
            skipEnabled(1);
            timer->start(scansionGap);
        }
        else
        {
            if (scansionMode == 2)
                skipEnabled(1);
        }
    }
}

void qualisoftWindow::premuto3()
{
    QPalette palette;

    if (pushButton_3->text() == pExercise->esatto())
    {
        lcdNumber_1->display(lcdNumber_1->intValue()+1);
        pushButton_avanti->setEnabled(true);
        label_3->setText(label_3->text()+' ' +pushButton_3->text());
        enableButtons(false);
        label_4->setPixmap(QPixmap(m_resource_path + "smile.png"));
        if (scanOn)
        {
            timer->stop();
            if (scansionMode == 1)
            {
                palette.setColor(QPalette::Button,color_button);
                pushButton_3->setPalette( palette );
                palette.setColor(QPalette::Button,scansionColor);
                pushButton_avanti->setPalette( palette );
            }
            else
            {
                //moveRect(pushButton_3,pushButton_avanti);
            }
            pushButton_avanti->setFocus();
        }
    }
    else
    {
        lcdNumber_2->display(lcdNumber_2->intValue()+1);
        label_4->setPixmap(QPixmap(m_resource_path + "frown.png"));
        pushButton_3->setEnabled(false);
        if (scanType == 1)
        {
            if (scansionMode == 1)
            {
                palette.setColor(QPalette::Button,color_button);
                pushButton_3->setPalette( palette );
            }
            skipEnabled(2);
            timer->start(scansionGap);
        }
        else
        {
            if (scansionMode == 2)
                skipEnabled(2);
        }
    }
}

void qualisoftWindow::premuto4()
{
    QPalette palette;
    if (pushButton_4->text() == pExercise->esatto())
    {
        lcdNumber_1->display(lcdNumber_1->intValue()+1);
        pushButton_avanti->setEnabled(true);
        label_3->setText(label_3->text()+' ' +pushButton_4->text());
        enableButtons(false);
        label_4->setPixmap(QPixmap(m_resource_path + "smile.png"));
        if (scanOn)
        {
            timer->stop();
            if (scansionMode == 1)
            {
                palette.setColor(QPalette::Button,color_button);
                pushButton_4->setPalette( palette );
                palette.setColor(QPalette::Button,scansionColor);
                pushButton_avanti->setPalette( palette );
            }
            else
            {
                //moveRect(pushButton_4,pushButton_avanti);
            }
            pushButton_avanti->setFocus();
        }
    }
    else
    {
        lcdNumber_2->display(lcdNumber_2->intValue()+1);
        label_4->setPixmap(QPixmap(m_resource_path + "frown.png"));
        pushButton_4->setEnabled(false);
        if (scanType == 1 )
        {
            if (scansionMode == 1)
            {
                palette.setColor(QPalette::Button,color_button);
                pushButton_4->setPalette( palette );
            }
            skipEnabled(3);
            timer->start(scansionGap);
        }
        else
        {
            if (scansionMode == 2)
                skipEnabled(3);
        }
    }
}

void qualisoftWindow::premuto5()
{
    QPalette palette;
    if (pushButton_5->text() == pExercise->esatto())
    {
        lcdNumber_1->display(lcdNumber_1->intValue()+1);
        pushButton_avanti->setEnabled(true);
        label_3->setText(label_3->text()+' ' +pushButton_5->text());
        enableButtons(false);
        label_4->setPixmap(QPixmap(m_resource_path + "smile.png"));
        if (scanOn)
        {
            timer->stop();
            if (scansionMode == 1)
            {
                palette.setColor(QPalette::Button,color_button);
                pushButton_5->setPalette( palette );
                palette.setColor(QPalette::Button,scansionColor);
                pushButton_avanti->setPalette( palette );
            }
            else
            {
                //moveRect(pushButton_5,pushButton_avanti);
            }
            pushButton_avanti->setFocus();
        }
    }
    else
    {
        lcdNumber_2->display(lcdNumber_2->intValue()+1);
        label_4->setPixmap(QPixmap(m_resource_path + "frown.png"));
        pushButton_5->setEnabled(false);
        if (scanType == 1 )
        {
            if (scansionMode == 1)
            {
                palette.setColor(QPalette::Button,color_button);
                pushButton_5->setPalette( palette );
            }
            //pushButton_1->setPaletteBackgroundColor(form_scansione->cScan());
            //pushButton_1->setFocus();
            skipEnabled(4);
            timer->start(scansionGap);
        }
        else
        {
            if (scansionMode == 2)
                skipEnabled(4);
        }
    }
}

void qualisoftWindow::avanti()
{

    QString a[5],f;
    QFont font;
    int l,button_width,button_height,half_screen;
    QPoint new_position;
    QPalette palette;
    //QSound sound("./suono.wav");


    pushButton_avanti->setEnabled(false);
    pExercise->frase(&a[0],f);
    label_3->setText(f);
    pushButton_1->setText(a[0]);
    pushButton_2->setText(a[1]);
    pushButton_3->setText(a[2]);
    pushButton_4->setText(a[3]);
    pushButton_5->setText(a[4]);


    pushButton_1->setFocus();;
    enableButtons(true);


    /*
    font=pushButton_1->font();
    QFontMetrics fm(font);
    QFontInfo b(font);

    l=QMAX(fm.width(pushButton_1->text()),fm.width(pushButton_2->text()));
    l=QMAX(l,fm.width(pushButton_3->text()));
    l=QMAX(l,fm.width(pushButton_4->text()));
    l=QMAX(l,fm.width(pushButton_5->text()));


    button_width=l+10;
    button_height=b.pixelSize()+10;

    half_screen=(int)(this->width()/2);
    pushButton_1->setGeometry(half_screen-button_width-10,200,button_width,button_height);
    pushButton_2->setGeometry(half_screen+10,200,button_width,button_height);
    pushButton_3->setGeometry((int)(half_screen-button_width/2),200+button_height+10,button_width,button_height);
    pushButton_4->setGeometry(half_screen-button_width-10,200+2*(button_height+10),button_width,button_height);
    pushButton_5->setGeometry(half_screen+10,200+2*(button_height+10),button_width,button_height);  */

    //sound.play();

    if (scanOn)
    {
        if (scansionMode == 1)
        {


            palette.setColor(QPalette::Button,scansionColor);
            pushButton_1->setPalette( palette );
            palette.setColor(QPalette::Button,color_button);
            pushButton_avanti->setPalette( palette );
        }
        else
        {
            //moveRect(pushButton_avanti,pushButton_1);
        }
        pushButton_1->setFocus();

        if (scanType == 1)
            timer->start(scansionGap);
    }

  label_4->clear();
}

void qualisoftWindow::restart()
{
    QString a[5],f;
    pExercise->frase(&a[0],f);
    label_3->setText(f);

    pushButton_1->setText(a[0]);
    pushButton_2->setText(a[1]);
    pushButton_3->setText(a[2]);
    pushButton_4->setText(a[3]);
    pushButton_5->setText(a[4]);

    enableButtons(true);
    lcdNumber_1->display(0);
    lcdNumber_2->display(0);
    pushButton_avanti->setEnabled(false);
    label_4->setPixmap(QPixmap(m_resource_path + "smile.png"));

    pushButton_1->setFocus();
}

// Skip at next button enabled. Current is current button clicked 0..4
void qualisoftWindow::skipEnabled(int current)
{
    int i;
    QPushButton *vet[5];
    QPalette palette;

    vet[0] = pushButton_1;
    vet[1] = pushButton_2;
    vet[2] = pushButton_3;
    vet[3] = pushButton_4;
    vet[4] = pushButton_5;

    i = current;
    while (!vet[(++i)%5]->isEnabled());

    vet[i%5]->setFocus();

    if (scansionMode == 1)
    {
        palette.setColor(QPalette::Button,scansionColor);
        vet[i%5]->setPalette( palette );
    }
    /*
      per la scansione a rettangolo si muove il rect
    */
    /*if(form_scansione->howScan()==2)
      moveRect(vet[current],vet[i%5]);*/

}


void qualisoftWindow::keyReleaseEvent( QKeyEvent *k )
{
    int i;
    bool trovato;
    QPushButton *vet[5];
    QPalette paletteCurrentButton;
    QColor colorCurrentButton;



    if (scanOn && scanType == 1 && !k->isAutoRepeat())
    {
        vet[0] = pushButton_1;
        vet[1] = pushButton_2;
        vet[2] = pushButton_3;
        vet[3] = pushButton_4;
        vet[4] = pushButton_5;


        i=0;
        trovato=false;
        if (scansionMode == 1)
        {
            while (i < 5 && !trovato)
            {
                paletteCurrentButton = vet[i]->palette();
                if ((colorCurrentButton = paletteCurrentButton.color(QPalette::Button)) == scansionColor)
                    trovato = true;
                i++;
            }
        }
        else
        {
            while (i < 5 && !trovato)
            {
                if (vet[i]->hasFocus())
                    trovato = true;
                i++;
            }
        }

        switch ( k->key() )
        {
        case Qt::Key_Space:
            if (pushButton_avanti->hasFocus())
            {
                avanti();
            }
            else
            {
                switch (i-1)
                {
                case 0:
                    premuto1();
                    break;
                case 1:
                    premuto2();
                    break;
                case 2:
                    premuto3();
                    break;
                case 3:
                    premuto4();
                    break;
                case 4:
                    premuto5();
                    break;
                default:
                    break;
                }
            }
            break;
        default:
            break;
        }
    }
}

void qualisoftWindow::keyPressEvent( QKeyEvent *k )
{
    int i;
    bool trovato;
    QPushButton *vet[5];
    //QPainter paint( this );
    QPalette paletteCurrentButton;
    QColor colorCurrentButton;


    if (scanOn && scanType == 2 && !k->isAutoRepeat())
    {
        vet[0] = pushButton_1;
        vet[1] = pushButton_2;
        vet[2] = pushButton_3;
        vet[3] = pushButton_4;
        vet[4] = pushButton_5;


        i = 0;
        trovato = false;
        if (scansionMode == 1)
        {
            while (i < 5 && !trovato)
            {
                paletteCurrentButton = vet[i]->palette();
                if ((colorCurrentButton = paletteCurrentButton.color(QPalette::Button)) == scansionColor)
                    trovato = true;

                i++;
            }
        }
        else
        {
            /* per scansione sil rettangolo ricerca sul focus*/
            while (i < 5 && !trovato)
            {
                if (vet[i]->hasFocus())
                    trovato = true;
                i++;
            }
        }


        switch ( k->key() )
        {
        case Qt::Key_Return :

            if (pushButton_avanti->hasFocus())
            {
                avanti();

            }
            else
            {
                switch (i-1)
                {
                case 0:
                    premuto1();
                    break;
                case 1:
                    premuto2();
                    break;
                case 2:
                    premuto3();
                    break;
                case 3:
                    premuto4();
                    break;
                case 4:
                    premuto5();
                    break;
                default:
                    break;
                }
            }

            break;
        case Qt::Key_Space:
            /* se il current e' il button6*/
            if (!pushButton_avanti->hasFocus())
            {
                i--;
                if (scansionMode == 1)
                {
                    QPalette palette;
                    palette.setColor(QPalette::Button,color_button);
                    vet[i]->setPalette(palette);
                }
                skipEnabled(i);

            }
            break;
        default:
            break;
        }
    }
    else if ( scanOn && scanType == 1 && !k->isAutoRepeat())
    {
        switch ( k->key() )
        {
        case Qt::Key_Space:
            timer->stop();
            break;
        default:
            break;
        }
    }
}

void qualisoftWindow::timeout()
{
    int i;
    bool trovato;
    QPushButton *vet[5];
    QPalette paletteCurrentButton;
    QColor colorCurrentButton;

    vet[0] = pushButton_1;
    vet[1] = pushButton_2;
    vet[2] = pushButton_3;
    vet[3] = pushButton_4;
    vet[4] = pushButton_5;

    i = 0;
    trovato = false;
    if (scansionMode == 1)
    {
        // per scansione con colore. ricerca sul colore del button.
        while (i < 5 && !trovato)
        {
            paletteCurrentButton = vet[i]->palette();
            if ((colorCurrentButton = paletteCurrentButton.color(QPalette::Button)) == scansionColor)
                trovato=true;
            i++;
        }
        paletteCurrentButton.setColor(QPalette::Button,color_button);
        vet[--i]->setPalette( paletteCurrentButton );
    }
    else
    {
        while (i < 5 && !trovato)
        {
            if (vet[i]->hasFocus())
                trovato=true;
            i++;
        }
        i--;
    }
    // se il focus e' su uno dei bottoni
    if (i <5 && trovato)
        skipEnabled(i);
}

void qualisoftWindow::scansione()
{
    QPalette standard,scansionPalette;
    standard.setColor(QPalette::Button,color_button);
    scansionDialog->exec();
    scansionDialog->scansionInfo(scansionColor,scanOn,scanType,scansionGap,scansionMode);
    scansionGap *= 1000;
    timer->stop();
    avanti();
    pushButton_1->setPalette( standard );
    pushButton_2->setPalette( standard );
    pushButton_3->setPalette( standard );
    pushButton_4->setPalette( standard );
    pushButton_5->setPalette( standard );
    pushButton_avanti->setPalette( standard );
    if (scanOn)
    {
        scansionPalette.setColor(QPalette::Button,scansionColor);
        if (scanType == 1) // scansione automatica
        {

            grabKeyboard();
            timer->start(scansionGap);

        }
        else
            grabKeyboard();  // scansione manuale blocca tastiera
        if (scansionMode == 1)
        {
            pushButton_1->setPalette( scansionPalette );

        }
        /*else
        // serve solo se howScan=2
           pen->setColor(scansionColor);*/
        pushButton_1->setFocus();
    }
    else
    {
        timer->stop();
        releaseKeyboard();

    }
}

void qualisoftWindow::info()
{
  QString title= QString(APPL_NAME) + " V. " + QString(APPL_VERSION);
  QString info = "(c) 2002 <b>Nicola De Filippo</b> - nicola@nicoladefilippo.it<br>"
                 "(c) 2009 <b>Angelo Naselli</b>    - anaselli@linux.it<br>";
  info += "http://educazionik.sourceforge.net";
  QString description = "Programma di esercizi per l'abbinamento degli aggettivi";
  QString icon = QString(RESOURCE_DIR) + "/logo.png";

  AboutDialog about(this, title, "", description, icon, "", "", "");
  about.exec();
}

void qualisoftWindow::enableButtons(bool en)
{
   pushButton_1->setEnabled(en);
   pushButton_2->setEnabled(en);
   pushButton_3->setEnabled(en);
   pushButton_4->setEnabled(en);
   pushButton_5->setEnabled(en);
}
