/* ============================================================
 *
 * This file is a part of educazionik project
 * http://educazionik.sourceforge.net/
 *
 * Date        : 30/10/2002
 * Description : Anagrammi implementation
 *
 * Copyright 2002-2009 by Nicola De Filippo <nicola@nicoladefilippo.it>
 * Copyright 2009      by Angelo Naselli    <anaselli at linux dot it>
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * ============================================================ */
#include"anagrammi.h"

QString anagrammi::m_data_path;

anagrammi::anagrammi(QString path)
{
  QString s;
  fd.setFileName(path);
  
  livello=1;
  completo=3;
  
  if ( fd.open(QIODevice::ReadOnly) )
  {
    t= new QTextStream( &fd );
    while( !t->atEnd() )
    {
      s = t->readLine();
      list_anagrammi.push_back(s);
    }
    error=0;
    for(int i=0;i<list_anagrammi.size();check.push_back(0),i++);
  }
  else
    error=-1;
  
  srand(time(0));
}

anagrammi::~anagrammi()
{
  fd.close();
}

void anagrammi::setLevel(int l)
{
  QString s,path;
  
  fd.close();
  
  path=m_data_path + "/";
  
  if(l==1)
    path+="lista1.txt";
  else if(l==2)
    path+="lista3.txt";
  else if(l==3)
    path+="lista2.txt";
  else
    path+="lista4.txt";
  
  
  fd.setFileName(path);
  
  livello=l;
  
  if(livello<3)
    completo=3;
  else
    completo=4;
  
  if ( fd.open(QIODevice::ReadOnly) )
  {
    delete t;
    list_anagrammi.clear();
    t= new QTextStream( &fd );
    while( !t->atEnd() )
    {
      s = t->readLine();
      list_anagrammi.push_back(s);
    }
    error=0;
    for(int i=0;i<list_anagrammi.size();check.push_back(0),i++);
  }
  else
    error=-1;
  
}
// return pezzi anagramma

void anagrammi::anagramma(QString a[4])
{
  QString s,dum;
  int i,j,peso;
  bool trovato=false;
  
  
  
  j=(int) (((double)list_anagrammi.size())*rand()/(RAND_MAX));
  
  while (!trovato)
  {
    
    if(check[j]!=0)
    {
      check[j]=0;
      j=(int) (((double)list_anagrammi.size())*rand()/(RAND_MAX));
    }
    else
    {
      trovato=true;
      check[j]=1;
    }
  }
  
  check[j]=1;
  n_anagramma=j;
  s=list_anagrammi[j];
  a[0] = s.section(',',0,0);
  a[1] = s.section(',',1,1);
  a[2] = s.section(',',2,2);
  
  peso=3;
  
  if(livello >= 3)
  {
    a[3]= s.section(',',3,3);
    peso=4;
  }
  completo=peso;
  
  for(i=0;i<peso;i++)
  {
    j=(int) ((double)peso*rand()/(RAND_MAX));
    
    // caos in the vector
    dum=a[i];
    a[i]=a[j];
    a[j]=dum;
  }
}

// if pezzo in pos return 0 else -1

int anagrammi::verify_token(QString pezzo,int pos)
{
  QString s;
  s=list_anagrammi[n_anagramma];
  
  if(s.section(',',pos-1,pos-1)==pezzo)
  {
    completo--;
    return (0);
  }
  return(-1);
}

// Se  ogni pezzo  a posto  completo
int anagrammi::esatto()
{
  if(!completo)
    return (0);
  return(-1);
}  

int anagrammi::errore()
{
  return error;
}

int anagrammi::level()
{
  return (livello);
}
