/* ============================================================
 *
 * This file is a part of educazionik project
 * http://educazionik.sourceforge.net/
 *
 * Date        : 16/03/2003
 * Description : Difficolta' ortografiche implementation
 *
 * Copyright 2003-2009 by Nicola De Filippo <nicola@nicoladefilippo.it>
 * Copyright 2009      by Angelo Naselli    <anaselli at linux dot it>
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * ============================================================ */
#include "dialoggame.h"
#include "ui_game.h"

#include "difficoltaortografiche_version.h"

#include <QMessageBox>

DialogGame::DialogGame(QWidget *parent)
    : QDialog(parent), ui(new Ui::DialogGame)
{
    ui->setupUi(this);
}

void DialogGame::sinistro()
{
    QString frase;
    int i;


    frase = ui->TextLabel1->text();

    i=frase.indexOf('_');
    frase.remove(i,frase.lastIndexOf('_')-i+1);
    frase.insert(i,ui->PushButton32->text());

    if(ui->PushButton32->text()==pdiff->esatto())
    {
      ui->LCDNumber1->display(ui->LCDNumber1->intValue()+1);
      ui->TextLabel1->setText(frase);
      ui->PushButton34->setEnabled(true);
      ui->PushButton32->setEnabled(false);
      ui->PushButton33->setEnabled(false);
      ui->PushButton6->setEnabled(false);
      ui->PushButton7->setEnabled(false);
      ui->PushButton8->setEnabled(false);
      ui->TextLabel4->setPixmap(QPixmap(QString(RESOURCE_DIR) + "/smile.png"));

      if(automatico) this->avanti();
    }
    else
    {
      ui->LCDNumber2->display(ui->LCDNumber2->intValue()+1);
      ui->TextLabel4->setPixmap(QPixmap(QString(RESOURCE_DIR) + "/frown.png"));
    }
}

void DialogGame::destro()
{
    int i;
    QString frase;

    frase = ui->TextLabel1->text();

    i = frase.indexOf('_');
    frase.remove(i,frase.lastIndexOf('_')-i+1);
    frase.insert(i, ui->PushButton33->text());

    if(ui->PushButton33->text()==pdiff->esatto())
    {
      ui->LCDNumber1->display(ui->LCDNumber1->intValue()+1);
      ui->TextLabel1->setText(frase);
      ui->PushButton34->setEnabled(true);
      ui->PushButton32->setEnabled(false);
      ui->PushButton33->setEnabled(false);
      ui->PushButton6->setEnabled(false);
      ui->PushButton7->setEnabled(false);
      ui->PushButton8->setEnabled(false);
      ui->TextLabel4->setPixmap(QPixmap(QString(RESOURCE_DIR) + "/smile.png"));

      if(automatico) this->avanti();
    }
    else
    {
      ui->LCDNumber2->display(ui->LCDNumber2->intValue()+1);
      ui->TextLabel4->setPixmap(QPixmap(QString(RESOURCE_DIR) + "/frown.png"));
    }
}

void DialogGame::avanti()
{
    QString quiz;

    quiz = pdiff->frase();
    ui->TextLabel1->setText(quiz.section(',',0,0));
    ui->PushButton34->setEnabled(false);
    ui->PushButton32->setEnabled(true);
    ui->PushButton33->setEnabled(true);
    ui->PushButton6->setEnabled(true);
    ui->PushButton7->setEnabled(true);
    ui->PushButton8->setEnabled(true);
		ui->TextLabel4->clear();
}

void DialogGame::azzera()
{
	ui->LCDNumber1->display(0);
	ui->LCDNumber2->display(0);
	//Next is added to avoid forcing user to push avanti after resetting score
	avanti();
}

DialogGame::~DialogGame()
{
    delete ui;
    delete pdiff;
}


void DialogGame::openGame(QString scelta, bool senzaAvanti)
{
    QString path, destro, sinistro, quiz;

    automatico = senzaAvanti;



    ui->LCDNumber1->display(0);
    ui->LCDNumber2->display(0);
    ui->PushButton34->setEnabled(false);
    ui->PushButton32->setEnabled(true);
    ui->PushButton33->setEnabled(true);


    if(automatico)
      ui->PushButton34->hide();
    else
      ui->PushButton34->show();



    path = QString(DATA_DIR) + "/";
    sinistro = scelta.section('_',0,0);
    destro = scelta.section('_',1,1);

    this->setWindowTitle(sinistro+destro);

    pdiff= new s_diff(path + sinistro + destro + ".txt");

    if(!pdiff->errore())
    {
      quiz = pdiff->frase();

      //rimuove la desinenza dolce || duro

      if(destro.contains("dolce")>0)
         destro.remove(destro.length()-5,5);
      else if(destro.contains("duro")>0)
         destro.remove(destro.length()-4,4);
      if(sinistro=="gn" && destro=="")
      {
         sinistro="gna";
         destro="gne";
         ui->PushButton6->show();
         ui->PushButton6->setEnabled(true);
         ui->PushButton7->show();
         ui->PushButton7->setEnabled(true);
         ui->PushButton8->show();
         ui->PushButton8->setEnabled(true);
      }
      else
      {
         ui->PushButton6->hide();
         ui->PushButton7->hide();
         ui->PushButton8->hide();
      }
      ui->PushButton32->setText(sinistro);
      ui->PushButton33->setText(destro);
      ui->TextLabel1->setText(quiz.section(',',0,0));
    }
    else
    {
      ui->PushButton32->hide();
      ui->PushButton33->hide();
      ui->PushButton34->hide();
      ui->PushButton6->hide();
      ui->PushButton7->hide();
      ui->PushButton8->hide();
      QMessageBox::warning( this, tr("Difficolta' ortografiche"),
        tr("Il file contenente i dati non  stato trovato\n"));

    }
    this->exec();
}

void DialogGame::gno()
{
    QString frase;
    int i;


    frase= ui->TextLabel1->text();

    i=frase.indexOf('_');
    frase.remove(i,frase.lastIndexOf('_')-i+1);
    frase.insert(i, ui->PushButton6->text());

    if(ui->PushButton6->text()==pdiff->esatto())
    {
      ui->LCDNumber1->display(ui->LCDNumber1->intValue()+1);
      ui->TextLabel1->setText(frase);
      ui->PushButton34->setEnabled(true);
      ui->PushButton32->setEnabled(false);
      ui->PushButton33->setEnabled(false);
      ui->PushButton6->setEnabled(false);
      ui->PushButton7->setEnabled(false);
      ui->PushButton8->setEnabled(false);
      ui->TextLabel4->setPixmap(QPixmap(QString(RESOURCE_DIR) + "/smile.png"));

      if(automatico) this->avanti();
    }
    else
    {
      ui->LCDNumber2->display(ui->LCDNumber2->intValue()+1);
      ui->TextLabel4->setPixmap(QPixmap(QString(RESOURCE_DIR) + "/frown.png"));
    }
}

void DialogGame::gnu()
{
    QString frase;
    int i;


    frase=ui->TextLabel1->text();

    i=frase.indexOf('_');
    frase.remove(i,frase.lastIndexOf('_')-i+1);
    frase.insert(i,ui->PushButton7->text());

    if(ui->PushButton7->text()==pdiff->esatto())
    {
      ui->LCDNumber1->display(ui->LCDNumber1->intValue()+1);
      ui->TextLabel1->setText(frase);
      ui->PushButton34->setEnabled(true);
      ui->PushButton32->setEnabled(false);
      ui->PushButton33->setEnabled(false);
      ui->PushButton6->setEnabled(false);
      ui->PushButton7->setEnabled(false);
      ui->PushButton8->setEnabled(false);
      ui->TextLabel4->setPixmap(QPixmap(QString(RESOURCE_DIR) + "/smile.png"));

      if(automatico) this->avanti();
    }
    else
    {
      ui->LCDNumber2->display(ui->LCDNumber2->intValue()+1);
      ui->TextLabel4->setPixmap(QPixmap(QString(RESOURCE_DIR) + "/frown.png"));
    }
}

void DialogGame::gni()
{
    QString frase;
    int i;


    frase=ui->TextLabel1->text();

    i=frase.indexOf('_');
    frase.remove(i,frase.lastIndexOf('_')-i+1);
    frase.insert(i,ui->PushButton8->text());

    if(ui->PushButton8->text()==pdiff->esatto())
    {
      ui->LCDNumber1->display(ui->LCDNumber1->intValue()+1);
      ui->TextLabel1->setText(frase);
      ui->PushButton34->setEnabled(true);
        ui->PushButton32->setEnabled(false);
      ui->PushButton33->setEnabled(false);
      ui->PushButton6->setEnabled(false);
      ui->PushButton7->setEnabled(false);
      ui->PushButton8->setEnabled(false);
      ui->TextLabel4->setPixmap(QPixmap(QString(RESOURCE_DIR) + "/smile.png"));

      if(automatico) this->avanti();

    }
    else
    {
      ui->LCDNumber2->display(ui->LCDNumber2->intValue()+1);
      ui->TextLabel4->setPixmap(QPixmap(QString(RESOURCE_DIR) + "/frown.png"));
    }
}
