/* ============================================================
 *
 * This file is a part of educazionik project
 * http://educazionik.sourceforge.net/
 *
 * Date        : 16/03/2003
 * Description : Difficolta' ortografiche implementation
 *
 * Copyright 2003-2009 by Nicola De Filippo <nicola@nicoladefilippo.it>
 * Copyright 2009      by Angelo Naselli    <anaselli at linux dot it>
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * ============================================================ */
#include "dialogmain.h"
#include "ui_dialogmain.h"
#include "dialogaltre.h"
#include <QMessageBox>
#include "dialogsimili.h"
#include "aboutdlg.h"
#include "difficoltaortografiche_version.h"

DialogMain::DialogMain(QWidget *parent)
        : QDialog(parent), ui(new Ui::DialogMain)
{
  ui->setupUi(this);
  QString title = QString(APPL_NAME)    + " V. " +
            QString(APPL_VERSION) + " ";
  setWindowIcon(QIcon( QPixmap(QString(RESOURCE_DIR) + "/educazionik.png")));
  setWindowTitle(title);
}

void DialogMain::simili()
{
    DialogSimili simili;
    simili.openSimili(ui->RadioButton2->isChecked());
}

void DialogMain::altre()
{
    DialogAltre altre;
    altre.openAltre(ui->RadioButton2->isChecked());
}

void DialogMain::info()
{
  QString title= QString(APPL_NAME) + " V. " + QString(APPL_VERSION);
  QString info = "(c) 2003 <b>Nicola De Filippo</b> - nicola@nicoladefilippo.it<br>"
                 "(c) 2009 <b>Angelo Naselli</b>    - anaselli@linux.it<br>";
  info += "http://educazionik.sourceforge.net";
  QString description = "Programma di esercizi sulle principali difficolta` ortografiche";
  QString icon = QString(RESOURCE_DIR) + "/logo.png";

  //AboutDialog about(this, title, info, description, icon);
  AboutDialog about(this, title, "", description, icon, "", "", "");
  about.exec();
}

DialogMain::~DialogMain()
{
    delete ui;
}
