/***************************************************************************
 *   Copyright (C) 2006 by Nicola De Filippo   *
 *   nicola@nicoladefilippo.it   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <sstream>
#include <iostream>
#include<stdlib.h>
#include "exercise.h"

Exercise::Exercise(string exp)
{
	current.setExpr(exp.c_str());
}

void Exercise::setExpr(string exp)
{
	current.setExpr(exp.c_str());
}

void Exercise::loadStep(vector<string> step)
{
	executed.clear();
	
	for(unsigned int i = 0; i < step.size() - 1; i++)
		executed[i] = step[i];
	
	current.setExpr((step.back()).c_str());
	
}


int Exercise::execNextStep(Z &res, string &newExpr)
{
	string exprText;
	ostringstream resStr;	
	Operation conf;
	int pos;

	if(isDone())
	{
		return current.getFirstNumber(res);
	
	}		
	
	if(!current.getNextOperation(pos))
	{
		
		if(!current.exec(pos,res))
		{

			
			executed.push_back(exprText);
			current._getExpr(newExpr, pos, res);
			
			current.setExpr(newExpr.c_str());
			
			return 0;

		}
		return -1;
	}
	
	return -1;
}


int Exercise::execStep(int pos, Z &res)
{
	string exprText;
	string newExpr;
	ostringstream resStr;	
	Operation conf;

	if(isDone())
	{
		return current.getFirstNumber(res);
	
	}		
        ////cout << "prima ecex " << res.getMaxString() << "\n";
	
	if(!current.exec(pos,res))
	{
                ////cout << "DOPO ecex " << res.getMaxString() << "\n";
		executed.push_back(exprText);
		current._getExpr(newExpr, pos, res);
		
		current.setExpr(newExpr.c_str());
	
		return 0;

	}
	return -1;
	
}



bool Exercise::isDone()
{
        ////cout << "++ isDone size " << current.size() <<"\n";
	if(current.size() == 1)
	{
		Z number;
		current.getFirstNumber(number);
		if(number.isSimple())
			return true;
	}
	return false;
}


void Exercise::expr(string &text)
{
	char *expText;

	expText = (char *) malloc(current.getLenExpr() + 1);
	
	current.getExpr(expText);
	
	text = expText;
	free(expText);
}

void Exercise::upLoadExpr(vector<string> &step)
{
	string last;

	for(unsigned int i = 0; i < executed.size(); i++)
		step.push_back(executed[i]);
	
	expr(last);
	step.push_back(last);
	
	//step = execute + current
}



/*
int main(int argc,char *argv[])
{
	string txt;
	Z r;
	Exercise prova("1+2");
	int i;
	
	//Expression p("((7))");
	//./Exercise '2+2*5+(4*3)'
	//
	prova.setExpr("1+(-7)");
	prova.expr(txt);
        //cout << "L'espressione da valutare e' " << txt << "\n";

	i = 0;

	if(!prova.execStep(1,r))
	{

                //cout << " risultato passo precedente " << r.toString() <<"\n";
	}
	else
                //cout << "ERRORE\n";
	return 0;
}

*/
