#include "ui_exercise.h"
#include "exercise.h"
#include "newDialog.h"
#include "dialog_scansione.h"
//#include "scansionAlarm.h"
#include "dialogalarm.h"
#include "ZString.h"

#include <QDialog>
#include <QTimer>
#include <QMessageBox>
#include <QScrollBar>



#define SCAN_EXPRESSION		1
#define SCAN_RESULT		2

using namespace std;

class ExerciseGui : public QMainWindow, private Ui::MainWindow
{
	Q_OBJECT

	typedef enum {STEP, AUTO, FINAL} ResolutionType;


	Exercise *es;
	Expression current;
	vector <string> expressionElement;
	ZString strRes;
	QTableWidgetItem *currentItem;
	int sumColumnWidth; // To FUTURE
	dialogScansione *scansionDialog;
	QTimer *timer;
	QTimer *timerResult;
	int scanType, scansionGap, scansionMode;
	bool scanOn;
	QColor scansionColor;
	int scanning;
	QScrollBar *horizontalBar;
        DialogAlarm *boxError;
	QString fileName;
	ResolutionType resolutionType;
	bool done; /* Exercise done */
	QFont font;
	QColor buttonColor;
	QColor textColor;
	QColor backgroundColor;
	QString currentOperation;
	NewDialog dialogNew;
	int nErrori;
	protected:
		/*!
		 * Draw tableWidget
		 * NOTE: mabye FUTURE not implemented
		 */
		void tableDraw();
		void keyPressEvent( QKeyEvent * );
		void keyReleaseEvent( QKeyEvent * );
		
		/*!
		 * Load saved setting (or default)
		 */
		void loadSetting();
		
		/*!
		 * Set graphics setting
		 */
		
		void setSetting();
		
	public:
		ExerciseGui(QWidget *parent = 0);
		
	public slots:
		void click(QTableWidgetItem * item);
		
		void verificResult();
		void newExercise();
		void printSteps();
		void changeFont();
		void changeBackgroundColor();
		void changeButtonColor();
		void changeTextColor();
		void scansion();
		void automaticResolution();
		void stepResolution();
		void loadDefaultExercise();
		void fileLoad();
		void fileSave();
		void fileSaveAs();
		void finalResult();
		void settingSave();
		void timeout();
		void timeoutResult();
		void pressed1();
		void pressed2();
		void pressed3();
		void pressed4();
		void pressed5();
		void pressed6();
		void pressed7();
		void pressed8();
		void pressed9();
		void pressed0();
		void pressedSlash();
		void pressedMinus();
		void pressedDot();
		void pressedOk();
		void pressedDel();
		void info();
		void manual();
		void resetScore();
 };
