#include "qpushbuttonscansion.h"
#include <QPalette>
#include <QWindowsStyle>

QPushButtonScansion::QPushButtonScansion(QWidget *parent ): QPushButton(parent)
{
	QWindowsStyle a;
	scansionPalette.setColor(QPalette::Button,Qt::red);
	noScansionPalette = this->palette();
	setStyle(&a);
}

QPushButtonScansion::QPushButtonScansion(const QString & text, QWidget *parent): QPushButton(text, parent)
{
	QWindowsStyle a;
	scansionPalette.setColor(QPalette::Button,Qt::red);
	noScansionPalette = this->palette();
	setStyle(&a);
}

void QPushButtonScansion::focusOutEvent ( QFocusEvent * event )
{
	setPalette(noScansionPalette);
}

void QPushButtonScansion::focusInEvent ( QFocusEvent * event )
{
	setPalette(scansionPalette);
}

void QPushButtonScansion::setScansionColor(QColor color)
{
	scansionPalette.setColor(QPalette::Button, color);
	noScansionPalette = this->palette();
}
